org 400h

	TASTIERA equ 0h

	DMAC_P_CAR equ 1h
	DMAC_P_WC equ 2h
	DMAC_P_TRACCIA equ 3h
	DMAC_P_SETTORE equ 4h
	DMAC_P equ 4h

	TIMER equ 5h

	DMAC_B_WC equ 6h
	DMAC_B_TRACCIA equ 7h
	DMAC_B_SETTORE equ 8h
	DMAC_B equ 8h

	primarioTraccia dw 0
	primarioSettore db 0

	backupTraccia dw 0
	backupSettore db 0

	TEMPO equ 10 ; minuti da aspettare prima di far partire il backup

	buffer equ ABABh
	caratteri dl 0
	
code

	outl #TEMPO, TIMER
	start TIMER
	seti
	halt

; DRIVER TASTIERA
; Non interrompibile (primo nella daisy chain)

driver 0, 450h

	push R0 ; questo driver pu interrompere quello di DMAC_BACKUP

	clear TASTIERA ; Altrimenti riceviamo subito un'altra interruzione

	; Controlla se siamo arrivati a 100 caratteri
	movl caratteri, R0
	cmpl #100, R0
	jz trasferisci

	; Non siamo arrivati a 100 caratteri, acquisiscine un altro
	addl #buffer, R0
	inb TASTIERA, (R0)
	movl caratteri, R0
	addl #1, R0
	movl R0, caratteri
	pop R0
	rti

    trasferisci:
	; Tastiera deve essere inibita, e il DMAC_PRIMARIO deve partire
	; Prima di avviarlo, resettiamo il contatore del buffer per le prossime attivazioni
	movl #0, caratteri
	clrim TASTIERA
	outl #100, DMAC_P_WC
	outl #buffer, DMAC_P_CAR

	; Prendo traccia e settore dell'ultima scrittura di DISCO1
	outw primarioTraccia, DMAC_P_TRACCIA
	outb primarioSettore, DMAC_P_SETTORE

	start DMAC_P
	pop R0
	rti

; DRIVER DMAC_PRIMARIO
; Riattiva tastiera e memorizza il punto di arrivo nella scrittura

driver 1, 550h	
	clear DMAC_P
	setim TASTIERA
	inw DMAC_P_TRACCIA, primarioTraccia
	inb DMAC_P_SETTORE, primarioSettore
	rti


; DRIVER TIMER
; Avvia la creazione della copia di backup. I dischi hanno la stessa geometria,
; quindi parte da dove era arrivato nella copia precedente DMAC_BACKUP

driver 3, 600h
	clear TIMER ; per azzerare il flip flop Status. Timer viene riavviato in DMAC_B

    copiaBackup:
	outw backupTraccia, DMAC_B_TRACCIA
	outb backupSettore, DMAC_B_TRACCIA
	outl #100, DMAC_B_WC
	outl #buffer, DMAC_B_CAR
	start DMAC_B ; avvia la copia di backup tra i dischi
	rti

; DRIVER DMAC_BACKUP:
; Questo driver pu essere interrotto dalle altre periferiche
driver 4, 
	clear DMAC_B
	seti

	inw DMAC_B_TRACCIA, backupTraccia
	inb DMAC_B_SETTORE, backupSettore

	; Controlla se  stato memorizzato altro, nel frattempo
	movl primarioTraccia, R0
	cmpl backupTraccia, R0
	jnz copiaBackup

	movl primarioSettore, R0
	cmpl backupSettore, R0
	jnz copaBackup

	; non  stato copiato niente in pi, posso terminare
	rti	
end